Ignatius and the Princess I HDU

来源:互联网 发布:rpgmaker python 编辑:程序博客网 时间:2024/06/10 14:18

题目链接:点我


    The Princess has been abducted by the BEelzebub feng5166, our hero  Ignatius has to rescue our pretty Princess. Now he gets into feng5166's castle. The castle is a large labyrinth. To make the problem simply, we assume the labyrinth is a N*M two-dimensional array which left-top corner is (0,0) and right-bottom corner is (N-1,M-1). Ignatius enters at (0,0), and the door to feng5166's room is at (N-1,M-1), that is our target. There are some monsters in the castle, if Ignatius meet them, he has to kill them. Here is some rules:     1.Ignatius can only move in four directions(up, down, left, right), one step per second. A step is defined as follow: if current position is (x,y), after a step, Ignatius can only stand on (x-1,y), (x+1,y), (x,y-1) or (x,y+1).     2.The array is marked with some characters and numbers. We define them like this:     . : The place where Ignatius can walk on.     X : The place is a trap, Ignatius should not walk on it.     n : Here is a monster with n HP(1<=n<=9), if Ignatius walk on it, it takes him n seconds to kill the monster.     Your task is to give out the path which costs minimum seconds for Ignatius to reach target position. You may assume that the start position and the target position will never be a trap, and there will never be a monster at the start position. 

Input

    The input contains several test cases. Each test case starts with a line contains two numbers N and M(2<=N<=100,2<=M<=100) which indicate the size of the labyrinth. Then a N*M two-dimensional array follows, which describe the whole labyrinth. The input is terminated by the end of file. More details in the Sample Input. 

Output

    For each test case, you should output "God please help our poor hero." if Ignatius can't reach the target position, or you should output "It takes n seconds to reach the target position, let me show you the way."(n is the minimum seconds), and tell our hero the whole path. Output a line contains "FINISH" after each test case. If there are more than one path, any one is OK in this problem. More details in the Sample Output. 

Sample Input

5 6.XX.1...X.2.2...X....XX.XXXXX.5 6.XX.1...X.2.2...X....XX.XXXXX15 6.XX.....XX1.2...X....XX.XXXXX.

Sample Output

It takes 13 seconds to reach the target position, let me show you the way.1s:(0,0)->(1,0)2s:(1,0)->(1,1)3s:(1,1)->(2,1)4s:(2,1)->(2,2)5s:(2,2)->(2,3)6s:(2,3)->(1,3)7s:(1,3)->(1,4)8s:FIGHT AT (1,4)9s:FIGHT AT (1,4)10s:(1,4)->(1,5)11s:(1,5)->(2,5)12s:(2,5)->(3,5)13s:(3,5)->(4,5)FINISHIt takes 14 seconds to reach the target position, let me show you the way.1s:(0,0)->(1,0)2s:(1,0)->(1,1)3s:(1,1)->(2,1)4s:(2,1)->(2,2)5s:(2,2)->(2,3)6s:(2,3)->(1,3)7s:(1,3)->(1,4)8s:FIGHT AT (1,4)9s:FIGHT AT (1,4)10s:(1,4)->(1,5)11s:(1,5)->(2,5)12s:(2,5)->(3,5)13s:(3,5)->(4,5)14s:FIGHT AT (4,5)FINISHGod please help our poor hero.FINISH

题意:

问英雄能否从迷宫中救出公主,在迷宫中有怪兽,遇到怪兽就必须杀死它,问最少花费的时间.

思路:

bfs + 优先队列.由于题目中有怪兽会导致时间的差异,所以我们需要用优先队列使得每次都是从时间最小的地方扩展,这样才能保证最后的时间最小.还有一个问题就是路径记录的问题,

代码:

#include<cstdio>  #include<cstring>  #include<queue>  #include<stack>  using namespace std;  struct node  {      int x,y,t;      node(int a,int b,int c):x(a),y(b),t(c) {}//构造函数      void Set(int a,int b,int c)//设置函数      {          x=a;          y=b;          t=c;      }      bool operator <(const node &a)const//让优先队列的优先级:t小的,优先级高      {          return a.t<t;      }  };  struct node1  {      int x,y;  };  int n,m;  char mat[105][105];  bool vis[105][105];  node1 matt[105][105];//记录父亲坐标  int dir[4][2]= {1,0,0,1,-1,0,0,-1};  bool flag;  void bfs()  {      memset(vis,0,sizeof(vis));      priority_queue<node> Q;      node first=node(0,0,0);      Q.push(first);      vis[first.x][first.y]=1;      matt[0][0].x=0;      matt[0][0].y=0;      while(!Q.empty())      {          first=Q.top();          Q.pop();          if(first.x==n-1&&first.y==m-1)          {              flag=1;              printf("It takes %d seconds to reach the target position, let me show you the way.\n",first.t);              stack<node1> S;//把路径存储在栈里              node1 e;              e.x=n-1;              e.y=m-1;              S.push(e);              while(1)              {                  e=S.top();                  if(e.x==matt[e.x][e.y].x&&e.y==matt[e.x][e.y].y)                  {                      break;                  }                  node1 ee;                  ee.x=matt[e.x][e.y].x;                  ee.y=matt[e.x][e.y].y;                  S.push(ee);              }              for(int i=1; i<=first.t; i++)//输出路径              {                  printf("%ds:",i);                  if(mat[S.top().x][S.top().y]!='.')                  {                      printf("FIGHT AT (%d,%d)\n",S.top().x,S.top().y);                      mat[S.top().x][S.top().y]--;                      if(mat[S.top().x][S.top().y]=='0')                      {                          mat[S.top().x][S.top().y]='.';                      }                  }                  else                  {                      printf("(%d,%d)",S.top().x,S.top().y);                      S.pop();                      printf("->(%d,%d)\n",S.top().x,S.top().y);                  }              }              printf("FINISH\n");              break;          }          node next=node(0,0,0);          for(int i=0; i<4; i++)          {              int tx=first.x+dir[i][0];              int ty=first.y+dir[i][1];              if(tx>=n||tx<0||ty>=m||ty<0||vis[tx][ty]==1)              {                  continue;              }              else if(mat[tx][ty]=='X')              {                  continue;              }              else if(mat[tx][ty]=='.')              {                  next.Set(tx,ty,first.t+1);                  matt[tx][ty].x=first.x;                  matt[tx][ty].y=first.y;                  vis[tx][ty]=1;                  Q.push(next);              }              else              {                  next.Set(tx,ty,first.t+1+mat[tx][ty]-'0');                  vis[tx][ty]=1;                  matt[tx][ty].x=first.x;                  matt[tx][ty].y=first.y;                  Q.push(next);              }          }      }      if(!flag)          printf("God please help our poor hero.\nFINISH\n");  }  int main()  {      while(scanf("%d%d",&n,&m)==2)      {          for(int i=0; i<n; i++)          {              scanf("%s",mat[i]);          }          flag=0;          bfs();      }      return 0;  }
原创粉丝点击